% Function for displaying CFD results.  Called in PFBuoyant16_thesis.

function [uplot, vplot, wplot, pplot] = uvwpplots5(iteration, istore, jstore, kstore, nx, ny, nz, u, v, w, p, T)

T(1:nx+2,1:ny+2,1,1:2)=T(1:nx+2,1:ny+2,2,1:2);
T(1:nx+2,1:ny+2,nz+2,1:2)=T(1:nx+2,1:ny+2,nz+1,1:2);
T(1:nx+2,1,1:nz+2,1:2)=T(1:nx+2,2,1:nz+2,1:2);
T(1:nx+2,ny+2,1:nz+2,1:2)=T(1:nx+2,ny+1,1:nz+2,1:2);
T(1,1:ny+2,1:nz+2,1:2)=T(2,1:ny+2,1:nz+2,1:2);
T(nx+2,1:ny+2,1:nz+2,1:2)=T(nx+1,1:ny+2,1:nz+2,1:2);
prompt='Display surface plots? 0 for no, 1 for u plot, 2 for v, 3 for w, 4 for p, 5 for T.';
variable=input(prompt);
if variable~=0
    prompt='Select plane - 1 for x, 2 for y, 3 for z';
    plane=input(prompt);
else
    plane=0;
end

while plane~=0
    if plane==1

        while (variable~=0)==1 % u plot
            [uplot vplot wplot pplot Tplot i j k x y z]=deal(0);
            if variable==1
                xmax=istore-1
                prompt='Select x co-ordinate';
                i=input(prompt);
                if i>xmax
                    'This exceeds max x co-ordinate, x set to:'
                    i=xmax;
                    i
                end
                y=1:ny+2;
                z=ny+3:ny+nz+4;
                for j=1:ny+2
                    for k=1:nz+2
                        uplot(j,k)=u(i,j,k); % plots a slice of u at constant x
                    end
                end
                surf(z,y,uplot,'edgecolor','k','facecolor','interp');
            axis equal
            elseif variable==2 % v plot
                xmax=istore-1
                prompt='Select x co-ordinate';
                i=input(prompt);
                if i>xmax
                    'This exceeds max x co-ordinate, x set to:'
                    i=xmax;
                    i
                end
                y=1:ny+1;
                z=ny+2:ny+nz+3;
                for j=1:ny+1
                    for k=1:nz+2
                        vplot(j,k)=v(i,j,k); % plots a slice of v at constant x
                    end
                end
                surf(z,y,vplot,'edgecolor','k','facecolor','interp');
            axis equal
            elseif variable==3 % w plot
                xmax=istore-1
                prompt='Select x co-ordinate';
                i=input(prompt);
                if i>xmax
                    'This exceeds max x co-ordinate, x set to:'
                    i=xmax;
                    i
                end
                y=1:ny+2;
                z=ny+3:ny+nz+3;
                for j=1:ny+2
                    for k=1:nz+1
                        wplot(j,k)=w(i,j,k); % plots a slice of w at constant x
                    end
                end
                surf(z,y,wplot,'edgecolor','k','facecolor','interp');
            axis equal
            elseif variable==4 % p plot
                xmax=istore
                prompt='Select x co-ordinate';
                i=input(prompt);
                if i>xmax
                    'This exceeds max x co-ordinate, x set to:'
                    i=xmax;
                    i
                end
                y=1:ny+2;
                z=ny+3:ny+nz+4;
                for j=1:ny+2
                    for k=1:nz+2
                        pplot(j,k)=p(i,j,k,size(p,4)); % plots a slice of p at constant x
                    end
                end
                surf(z,y,pplot,'edgecolor','k','facecolor','interp');
                axis equal
            elseif variable==5 % T plot
                xmax=istore
                prompt='Select x co-ordinate';
                i=input(prompt);
                if i>xmax
                    'This exceeds max x co-ordinate, x set to:'
                    i=xmax;
                    i
                end
                y=1:ny+2;
                z=ny+3:ny+nz+4;
                for j=1:ny+2
                    for k=1:nz+2
                        Tplot(j,k)=T(i,j,k,2); % plots a slice of T at constant x
                    end
                end
                surf(z,y,Tplot,'edgecolor','k','facecolor','interp');
                axis equal
            end
            xlabel('z');
            ylabel('y');
view(2);
colorbar;
RangeChange=1;
while RangeChange==1
    prompt='Change legend range? 1 for yes, 0 for no.';
    if input(prompt)==0
        RangeChange=0;
    else
        prompt='Set legend minimum: ';
        RangeMin=input(prompt);
        prompt='Ser legend maximum: ';
        RangeMax=input(prompt);
        caxis([RangeMin,RangeMax]);
    end
end
        prompt='Display more surface plots in this plane? 0 for no, 1 for u plot, 2 for v, 3 for w, 4 for p, 5 for T.';
        variable=input(prompt);    

        end


    elseif plane==2
        while (variable~=0)==1 % u plot
            [uplot vplot wplot pplot Tplot i j k x y z]=deal(0);
                                    
            if variable==1 % u plot
                ymax=jstore-1
                prompt='Select y co-ordinate';
                j=input(prompt);
                if j>ymax
                    'This exceeds max y co-ordinate, y set to:'
                    j=ymax;
                    j
                end
                x=1:nx+1;
                z=nx+2:nx+nz+3;
                for i=1:nx+1
                    for k=1:nz+2
                        uplot(k,i)=u(i,j,k); % plots a slice of u at constant y
                    end
                end
                surf(x,z,uplot,'edgecolor','k','facecolor','interp');
axis equal
            elseif variable==2 % v plot
                ymax=jstore-1
                prompt='Select y co-ordinate';
                j=input(prompt);
                if j>ymax
                    'This exceeds max y co-ordinate, y set to:'
                    j=ymax;
                    j
                end
                x=1:nx+2;
                z=nx+3:nx+nz+4;
                for i=1:nx+2
                    for k=1:nz+2
                        vplot(k,i)=v(i,j,k); % plots a slice of v at constant y
                    end
                end
                surf(x,z,vplot,'edgecolor','k','facecolor','interp');
axis equal
            elseif variable==3 % w plot
                ymax=jstore-1
                prompt='Select y co-ordinate';
                j=input(prompt);
                if j>ymax
                    'This exceeds max y co-ordinate, y set to:'
                    j=ymax;
                    j
                end
                x=1:nx+2;
                z=nx+3:nx+nz+3;
                for i=1:nx+2
                    for k=1:nz+1
                        wplot(k,i)=w(i,j,k); % plots a slice of w at constant y
                    end
                end
                surf(x,z,wplot,'edgecolor','k','facecolor','interp');
axis equal
            elseif variable==4 % p plot
                ymax=jstore
                prompt='Select y co-ordinate';
                j=input(prompt);
                if j>ymax
                    'This exceeds max y co-ordinate, y set to:'
                    j=ymax;
                    j
                end
                x=1:nx+2;
                z=nx+3:nx+nz+4;
                for i=1:nx+2
                    for k=1:nz+2
                        pplot(k,i)=p(i,j,k,size(p,4)); % plots a slice of p at constant y
                    end
                end
                surf(x,z,pplot,'edgecolor','k','facecolor','interp');
                axis equal
            elseif variable==5 % T plot
                ymax=jstore
                prompt='Select y co-ordinate';
                j=input(prompt);
                if j>ymax
                    'This exceeds max y co-ordinate, y set to:'
                    j=ymax;
                    j
                end
                x=1:nx+2;
                z=nx+3:nx+nz+4;
                for i=1:nx+2
                    for k=1:nz+2
                        Tplot(k,i)=T(i,j,k,2); % plots a slice of T at constant y
                    end
                end
                surf(x,z,Tplot,'edgecolor','k','facecolor','interp');
                axis equal
            end
            
            xlabel('x');
            ylabel('z');
view(2);
colorbar;
RangeChange=1;
while RangeChange==1
    prompt='Change legend range? 1 for yes, 0 for no.';
    if input(prompt)==0
        RangeChange=0;
    else
        prompt='Set legend minimum: ';
        RangeMin=input(prompt);
        prompt='Ser legend maximum: ';
        RangeMax=input(prompt);
        caxis([RangeMin,RangeMax]);
    end
end
        prompt='Display more surface plots in this plane? 0 for no, 1 for u plot, 2 for v, 3 for w, 4 for p, 5 for T.';
        variable=input(prompt);    

        end

    elseif plane==3
        while (variable~=0)==1
            [uplot vplot wplot pplot Tplot i j k x y z]=deal(0);
            
            if variable==1 % u plot
                zmax=kstore-1
                prompt='Select z co-ordinate';
                k=input(prompt);
                if k>zmax
                    'This exceeds max z co-ordinate, z set to:'
                    k=zmax;
                    k
                end
                x=1:nx+1;
                y=nx+2:nx+ny+3;
                for i=1:nx+1
                    for j=1:ny+2
                        uplot(i,j)=u(i,j,k); % plots a slice of u at constant z
                    end
                end
                surf(y,x,uplot,'edgecolor','k','facecolor','interp');
axis equal
                elseif variable==2 % v plot
                zmax=kstore-1
                prompt='Select z co-ordinate';
                k=input(prompt);
                if k>zmax
                    'This exceeds max z co-ordinate, z set to:'
                    k=zmax;
                    k
                end
                x=1:nx+2;
                y=nx+3:nx+ny+3;
                for i=1:nx+2
                    for j=1:ny+1
                        vplot(i,j)=v(i,j,k); % plots a slice of v at constant z
                    end
                end
                surf(y,x,vplot,'edgecolor','k','facecolor','interp');
axis equal
                elseif variable==3 % w plot
                zmax=kstore-1
                prompt='Select z co-ordinate';
                k=input(prompt);
                if k>zmax
                    'This exceeds max z co-ordinate, z set to:'
                    k=zmax;
                    k
                end
                x=1:nx+2;
                y=nx+3:nx+ny+4;
                for i=1:nx+2
                    for j=1:ny+2
                        wplot(i,j)=w(i,j,k); % plots a slice of w at constant z
                    end
                end
                surf(y,x,wplot,'edgecolor','k','facecolor','interp');
axis equal
                elseif variable==4 % p plot
                zmax=kstore
                prompt='Select z co-ordinate';
                k=input(prompt);
                if k>zmax
                    'This exceeds max z co-ordinate, z set to:'
                    k=zmax;
                    k
                end
                x=1:nx+2;
                y=nx+3:nx+ny+4;
                for i=1:nx+2
                    for j=1:ny+2
                        pplot(i,j)=p(i,j,k,size(p,4)); % plots a slice of p at constant z
                    end
                end
                surf(y,x,pplot,'edgecolor','k','facecolor','interp');
                axis equal
                elseif variable==5 % T plot
                zmax=kstore
                prompt='Select z co-ordinate';
                k=input(prompt);
                if k>zmax
                    'This exceeds max z co-ordinate, z set to:'
                    k=zmax;
                    k
                end
                x=1:nx+2;
                y=nx+3:nx+ny+4;
                for i=1:nx+2
                    for j=1:ny+2
                        Tplot(j,i)=T(i,j,k,2); % plots a slice of T at constant z
                    end
                end
                surf(x,y,Tplot,'edgecolor','k','facecolor','interp');
                axis equal
            end
            
            xlabel('x');
            ylabel('y');
view(2);
colorbar;
RangeChange=1;
while RangeChange==1
    prompt='Change legend range? 1 for yes, 0 for no.';
    if input(prompt)==0
        RangeChange=0;
    else
        prompt='Set legend minimum: ';
        RangeMin=input(prompt);
        prompt='Ser legend maximum: ';
        RangeMax=input(prompt);
        caxis([RangeMin,RangeMax]);
    end
end
        prompt='Display more surface plots in this plane? 0 for no, 1 for u plot, 2 for v, 3 for w, 4 for p, 5 for T.';
        variable=input(prompt);    

        end

    end

prompt='More planes? 0 to end surface plots, 1 for x, 2 for y, 3 for z';
plane=input(prompt);
if plane~=0
prompt='Select plane: 1 for u plot, 2 for v, 3 for w, 4 for p, 5 for T.';
variable=input(prompt);
end

end